<template>
  <v-list-tile @click="$emit('click', $event)">
    <v-list-tile-action>
      <v-icon>mdi-package-variant-closed</v-icon>
    </v-list-tile-action>
    <v-list-tile-content>
      <v-list-tile-title>{{ name }}</v-list-tile-title>
      <v-list-tile-sub-title>{{ price }}</v-list-tile-sub-title>
    </v-list-tile-content>
    <v-spacer/>

    <slot name="actions" v-bind="product"/>
  </v-list-tile>
</template>

<script>
import gql from "graphql-tag";

export default {
  name: "card-list-item",
  props: {
    id: { type: String, required: true }
  },
  data() {
    return {
      product: null // Dialogs
    };
  },
  computed: {
    name() {
      if (!this.product) return null;
      return this.product.name;
    },
    price() {
      if (!this.product) return null;
      let integer = Math.floor(this.product.price / 100);
      let cents = this.product.price % 100;

      if (cents < 10) cents = "0" + cents;

      return `R$ ${integer},${cents}`;
    }
  },
  apollo: {
    product: {
      query: gql`
        query($id: ID!) {
          product(id: $id) {
            id
            name
            price
          }
        }
      `,
      subscribeToMore: {
        document: gql`
          subscription($id: ID!) {
            product(id: $id) {
              id
              name
              price
            }
          }
        `,
        variables() {
          return {
            id: this.id
          };
        }
      },
      variables() {
        return {
          id: this.id
        };
      }
    }
  }
};
</script>
